CHANGELOG
=========

2.4, 2025-02-03
---------------
- add support for generated columns
- add find/replace dialog to data grids and column editors and database schema text
- add dialog to manage shown and filtered columns in data grids; add EXACT- and NOT-option to column filter
- update known and deprecated pragma directives up to SQLite version 3.46
- upgrade embedded sqlite3_analyzer Windows binary from 3.29 to 3.43
- upgrade ANTLR version from 4.9 to 4.13
- upgrade snap distribution to Ubuntu 22 base using wxPython 4.2.0
- show STRICT checkbox for STRICT table in schema editor even if current SQLite does not support it
- add ANY as possible column type if SQLite version supports STRICT
- add SQL functions to SQL editors auto-completes
- add PRAGMA names as last column to PRAGMA window
- add execution history to SQL page toolbar
- improve converting changed values in table grids to original type for untyped columns
- fix and improve editing and movement in hex editor
- tweak initial size of resizable text controls in data grid row dialog
- re-hide hidden columns on refreshing data grid
- use double precision for floating-point values in column editor
- do not highlight changes in hex view in value editor tool
- do not reverse entities themselves in command-line interface on --reverse, only their rows
- mark changed pragma values with asterisks
- use unsaved changes when exporting table data grid to another database
- use hourglass cursor while showing busy message
- allow saving SVG image as SVG in column editor
- restore last active SQL window on opening database
- provide workaround for importing CSVs with mixed Windows and Unix linefeeds (issue #3)
- improve support for dark mode in Windows 10+
- improve layout speed in lengthy database lists
- fix parsing []-enclosed identifiers in CREATE SQL statements
- fix parsing context-specific keywords like ROWID and STRICT in identifiers
- fix data grids lagging with very long column values in Linux (issue #4)
- fix SQL query results starting to lag after lots of queries (issue #4)
- fix errors in data grid on opening virtual tables with hidden columns
- fix single instance checker stalling if existing instance has hung
- fix entities not being sorted case insensitively
- fix date arithmetic in automatic update check
- fix error on cancelling export to another database
- fix rolling back changes on error in schema editor test and save
- fix renaming columns in related entities on column rename for quoted or complex expressions
- fix error on keyword-only search
- fix representing very large integers in column editor hex view
- fix cutting and pasting text in column editor hex view
- fix logic and formatting issues in column editor date/time tab
- fix converting images to GIF in column editor image view
- fix edits being discarded in column editor after setting NULL
- fix compatibility issues with Python 3.6
- fix compatibility issues with Python 3.10+
- fix opening third-party license link in snaps
- fix accounting for relation lines in schema diagram zoom to fit
- fix pragma editor not disabling controls afterwards
- fix not having counts/bytes on schema diagram in statistics export
- fix renaming item in data/schema tree crashing in Linux
- fix diagram items shifting on select at certain zoom levels
- fix compiled binary crashing on waiting until timeout
- fix error on adding column to trigger in schema editor
- fix error on dropping table column used in related indexes or triggers
- fix error on selecting opened temporary database from tray menu
- fix not retaining complex ALTER TABLE results in related tables
- fix not updating info page and statistics on adding new schema entity
- fix not showing changes in write-only PRAGMA values
- add all user-executed SQL to action history not only action queries
- add "Refresh list" to database list context menu
- shorten SQL parsing error texts in schema editor popups
- refactor import-export functionality to classes
- update SQL grammar up to SQLite version 3.46
  (UPSERT, operator IS NOT? DISTINCT FROM, JSON operators -> ->>, window functions,
   MATERIALIZED in common table expression, UPDATE FROM in trigger body, RIGHT JOIN, FULL JOIN,
   ORDER BY in function calls, table alias in INSERT, column name list in UPDATE,
   underscore separator in numeric literals, all 147 keywords)


2.3, 2024-07-08
---------------
- add command-line interface, with execute, export, import, parse, pragma, search, and stats
- add option to rename SQL window pages
- add support for CREATE TABLE .. STRICT (Python 3.9+)
- add support for empty or whitespacey table and column and constraint names
- add support for column keyword in meta search
- add dark mode toggle to HTML export
- streamline choosing related items when exporting to another database
- include read-only pragmas in PRAGMA SQL
- include original encoding pragma in database recovery
- include current filter/sort/hidden settings in data grid export
- tweak spreadsheet properties content in Excel export, include SQL query
- show pragma SQL in view mode as well
- skip initial blank rows in spreadsheet imports
- change default item action on diagram from opening schema to opening data
- update SQLite keywords from 126 to the latest 147-element list
- use a custom lockfile implementation for single instance check in Linux
- show descriptive error when trying to save view with blank column names
- skip hidden columns in data grid exports
- fix saving nested structures in JSON/YAML data import
- fix auto_vacuum and encoding pragmas not being editable in new databases
- fix updating main page upon removing databases when home-row is also selected
- fix foreign key constraint editor not allowing to add a column in duplicate
- fix entering new value in column/constraint editor editable comboboxes like column type
- fix rows-toggle not toggling data table in single item HTML export
- fix working with exotic characters in value editor
- change strip alphanumeric/non-alphanumeric strip functions to text/non-text
- make "Toggle all" toggle item CREATE SQL statements in combined HTML export
- add program version number and date to HTML export metadata
- fix intermittent mouse event error on diagram
- fix diagram selection rectangle font issues in Linux
- fix data leaks from orphaned background threads and dangling references
- improve handling tables WITHOUT ROWID
- restore program window on unminimizing from tray if window iconized
- ensure dialog windows get destroyed when closed
- tweak export panel buttons and layout
- tweak column/constraint editor layout
- disable automatic update checks and downloads in snaps
- include third-party license texts in snaps and stand-alone exes
- use latest custom-built PyInstaller 6.7 for producing binaries
- use _x86 suffix for 32-bit binaries, drop _x64 suffix from 64-bit binaries


2.2, 2023-10-08
---------------
- add line number and word-wrap toggles to more controls
- add diagram export to Tools-menu
- add option to export diagram with selected entities
- add refresh-button and copy-button to diagram toolbar
- add option to copy diagram image to clipboard
- add IF NOT EXISTS to schema editor
- add "Go to row" button to data dialog
- add YAML formatting options to value editor
- open databases in autocommit mode
- highlight open databases in database list
- unify context menus in data and schema trees
- retain undo history when loading SQL from file to SQL editor
- improve adding final semicolon to user-entered commented CREATE SQL
- improve compatibility with wxPython 4.2+
- speed up Excel export by improved caching for column width calculation
- speed up populating hex/byte editors in value editor
- fix error on changing column order in trigger/view editor
- fix error on reindexing table from diagram if table has no index
- fix error on checking foreign keys if foreign table has no primary key
- fix error on toolbar actions upon action query results in SQL editor
- fix error on loading SVG image in value editor
- fix user-defined function remaining inactive if saved without explicit compiling
- fix numeric spinctrls in pragma editor having invalid range
- fix detecting multiple statements in user-entered CREATE SQL
- fix ambiguity in parsing INDEX expressions with COLLATE
- fix value editor raising error on program exit
- fix Excel export error, from breaking changes in PIL
- drop step as a vendored library, use from public package index instead


2.1, 2023-08-16
---------------
- add user-defined functions to value editor
- add button panels to data and schema tabs
- add NULL column icons to schema diagram
- add column and key toggles to schema diagram
- add option to hide data grid columns
- add filter and hide column options in grid row context menu
- add support for multiple item export into any supported output format
- add command-line flag --config-file
- add NULLS FIRST|LAST to SQLite grammar ORDER BY clause
- add splitter to program main page
- add file encoding detection in CSV import, improve CSV dialect detection
- order database categories as table-view-index-trigger
- use uniform icons for schema tree items
- retain schema diagram custom layout on schema change
- support index and trigger keywords in meta search
- support importing structured data from YAML to database
- support importing JSON files containing a single dict
- support TIMESTAMP as date column type in search
- omit comments from JSON export
- underline matched texts in meta search results
- include journal file sizes in database size
- improve compatibility with GTK and Python 3.8+ on Linux.
- update step, the vendored template library
- fix loading user-specific configuration file
- fix schema diagram not loading entity positions from last config
- fix schema diagram adopting custom layout on clicking an entity
- fix collecting related entities on getting all related SQL or exporting to another database
- fix error on canceling a single grid export
- fix error on toggling diagram foreign labels on
- fix diagram in statistics HTML export using current view settings
- fix operating on key columns of BLOB affinity in data grids
- fix encoding errors in running disk usage analyzer
- fix escaping special characters for regex in exported HTML search functions
- fix complex alter ignoring related triggers (SQLite 3.25+ compatibility)
- fix JSON/YAML import not using column names from data
- fix spreadsheet import using same columns for all sheets


2.0, 2022-04-02
---------------
- add schema diagram, exportable as bitmap or vector
- add data import wizard
- add option to create database from spreadsheet or JSON
- add option to have only single instance running
- add option to clone a table or view
- add option to drop entire schema
- add support for single-user install
- add easy rename options to data & schema tree
- add easy drop column options to data & schema tree
- add spreadsheet file drag-drop support to database page
- add YAML support
- add Dockerfile
- full Python2 / Python3 compatibility
- improve auto-altering related items
- move to src-layout
- many fixes and UI tweaks


1.1, 2020-08-08
---------------
- add value editor tool
- add transform and date options to column value editor
- use OS- and user-specific config directory where necessary
- bugfixes and UI tweaks


1.0, 2020-07-07
---------------
- first public release
